<!DOCTYPE html>
<html>
<head>
<title>haroldbot (permute)</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
<link rel="shortcut icon" href="/favicon.ico" />
<link rel="stylesheet" type="text/css" href="mainstyle.css" />
<script type="text/javascript" src="minisat.js"></script>
<script type="text/javascript" src="jquery-1.12.4.min.js"></script>
<script type="text/javascript" src="jquery.color-2.1.2.min.js"></script>
<script type="text/javascript" src="util.js"></script>
<script type="text/javascript">
var $j = jQuery.noConflict();

function extract_bit_indexes(bitpos) {
  let inv = new Int32Array(512);
  for (let i = 0; i < 512; i++)
    inv[bitpos[i]] = i;
  let indexes = new Int32Array(9);
  let had = 0;
  for (let i = 0; i < 9; i++) {
    let s = 0xFFFFFF & ~had;
    for (let j = 0; j < 512; j++) {
      let bit_i_of_actual = (inv[j] >> i) & 1;
      for (let m = 0; m < 24; m++) {
        let bit_m_of_j = ((j >> (m >> 1)) ^ m) & 1;
        if (bit_i_of_actual != bit_m_of_j)
          s &= ~(1 << m);
      }
      
      if (s == 0)
        return null;
    }

    if (s == 0)
      return null;

    let t = ctz(s);
    had |= 3 << (t & -2);
    t = (t >> 1) ^ -(t & 1);
    indexes[i] = t;
  }

  return indexes;
}

function multiply(A, B) {
  let R = new Int32Array(9);
  for (let i = 0; i < 9; i++) {
    let xa = A[i];
    R[i] = B[xa ^ (xa >> 31)] ^ (xa >> 31);
  }
  return R;
}

function inverse(A) {
  let R = new Int32Array(9);
  for (let i = 0; i < 9; i++) {
    let xa = A[i];
    R[xa ^ (xa >> 31)] = i ^ (xa >> 31);
  }
  return R;
}

function solveSingleStep(action) {
  function solveS(action) {
    if (action.slice(0, 3).every((a, i) => a === i) &&
      action.slice(3).every(a => (a ^ (a >> 31)) >= 3)) {
      return { 'kind': 'S', 'action': action.slice() };
    }
    return null;
  }
  function solveP(action) {
    if (action.slice(0, 3).every(a => (a ^ (a >> 31)) < 3) &&
      action.slice(3).every((a, i) => a === i + 3)) {
      return { 'kind': 'P', 'action': action.slice() };
    }
    return null;
  }
  function solveQ(action) {
    if (action.slice(0, 3).every((a, i) => ~a === i + 3) &&
      action.slice(3, 6).every(a => (a ^ (a >> 31)) < 3) &&
      action.slice(6).every((a, i) => a === i + 6)) {
      return { 'kind': 'Q', 'action': action.slice() };
    }
    return null;
  }
  return solveS(action) || solveP(action) || solveQ(action);
}

function solveTwoStep(action, all) {
  function solveSQ(action) {
    // top three bits can be any function of original top 6 bits
    // middle three bits can be any function of original bottom 3 bits
    // bottom three bits can be any function of original top 6 bits
    if (action.every((a, i) =>  {
      if (i < 3)
        return (a ^ (a >> 31)) >= 3;
      if (i < 6)
        return (a ^ (a >> 31)) < 3;
      return (a ^ (a >> 31)) >= 3;
    })) {
      let actionS = new Int32Array(9);
      actionS.set([0, 1, 2]);
      actionS.set(action.slice(0, 3).map(b => ~b), 3);
      actionS.set(action.slice(6), 6);
      let S = solveSingleStep(actionS);
      let actionQ = multiply(action, inverse(actionS));
      let Q = solveSingleStep(actionQ);
      if (S && Q)
        return [S, Q];
    }
    return null;
  }
  function solveQS2(action) {
    // 7,8 unchanged
    // middle four bits can be any function of bits [0..2, 6]
    // bottom three bits must be original middle 3 bits inverted
    if (action.every((a, i) =>  {
      if (i < 3)
        return ~a === i + 3;
      if (i >= 7)
        return a === i;
      return true;
    })) {
      let actionS = new Int32Array([0, 1, 2, 3, 4, 6, 5, 7, 8]);
      {
        let actionQ = multiply(inverse(actionS), action);
        let Q = solveSingleStep(actionQ);
        let S = solveSingleStep(actionS);
        if (Q && S)
          return [Q, S];
      }
      actionS = new Int32Array([0, 1, 2, 3, 4, ~6, 5, 7, 8]);
      {
        let actionQ = multiply(inverse(actionS), action);
        let Q = solveSingleStep(actionQ);
        let S = solveSingleStep(actionS);
        if (Q && S)
          return [Q, S];
      }
      actionS = new Int32Array([0, 1, 2, 3, 4, 5, ~6, 7, 8]);
      {
        let actionQ = multiply(inverse(actionS), action);
        let Q = solveSingleStep(actionQ);
        let S = solveSingleStep(actionS);
        if (Q && S)
          return [Q, S];
      }
    }
    return null;
  }
  function solveQS(action) {
    // top six bits can be any function of bits [0..2, 6..8]
    // bottom three bits must be original middle 3 bits inverted
    if (action.every((a, i) =>  {
      if (i < 3)
        return ~a === i + 3;
      return (a ^ (a >> 31)) < 3 || (a ^ (a >> 31)) >= 6;
    })) {
      let actionQ = new Int32Array([~3, ~4, ~5, 0, 1, 2, 6, 7, 8]);
      let Q = solveSingleStep(actionQ);
      let actionS = multiply(action, inverse(actionQ));
      let S = solveSingleStep(actionS);
      if (Q && S)
        return [Q, S];
    }
    return null;
  }
  function solvePS(action) {
    // top six bits can be any function of top six bits
    // bottom three bits can be any function of bottom six bits
    // top and bottom are independent
    if (action.every((a, i) =>  {
      if (i < 3)
        return (a ^ (a >> 31)) < 3;
      return (a ^ (a >> 31)) >= 3;
    })) {
      let actionP = new Int32Array(9);
      for (let i = 0; i < 9; i++)
        actionP[i] = i;
      actionP.set(action.slice(0, 3));
      let P = solveSingleStep(actionP);
      let actionS = multiply(action, inverse(actionP));
      let S = solveSingleStep(actionS);
      if (P && S)
        return [P, S];
    }
    return null;
  }
  if (all)
    return [solveSQ(action), solveQS2(action), solveQS(action), solvePS(action)].filter(s => s != null);
  return solveSQ(action) || solveQS2(action) || solveQS(action) || solvePS(action);
}

function solveSQS(action) {
  // bottom three bits can be any function of top six bits
  // top six bits must have the bottom three bits in them somehow via some mapping
  if (action.every((a, i) => {
    if (i < 3)
      return (a ^ (a >> 31)) >= 3;
    return true;
  })) {
    let actionS = new Int32Array(9);
    actionS.set([0, 1, 2]);
    actionS.set(action.slice(0, 3), 3);
    let had = 0;
    for (let i = 0; i < 6; i++)
      had |= 1 << (actionS[i] ^ (actionS[i] >> 31));
    for (let i = 6; i < 9; i++) {
      actionS[i] = ctz(~had & 0x1FF);
      had |= had + 1;
    }

    for (let m = 0; m < 64; m++) {
      let actionSM = actionS.map((a, i) => a ^ -((((m ^ 7) << 3) >> i) & 1));
      let S = solveSingleStep(actionSM);
      let actionRem = multiply(action, inverse(actionSM));
      let Rem = solveTwoStep(actionRem);
      if (S && Rem)
        return [S, ...Rem];
    }
  }
  return null;
}

function solveSQSQS(action) {
  // ???
  let areInBottom = 0;
  for (let i = 0; i < 3; i++)
    areInBottom |= 1 << (action[i] ^ (action[i] >> 31));
  let actionS = new Int32Array(9);
  actionS.set([0, 1, 2]);
  let M1 = 0x1F8 & areInBottom;
  let M2 = 0x1F8;
  for (let i = 0; i < 3; i++) {
    actionS[i + 6] = ctz(M1 == 0 ? M2 : M1);
    M2 &= ~(1 << actionS[i + 6]);
    M1 &= M1 - 1;
  }
  for (let i = 0; i < 3; i++) {
    actionS[i + 3] = ~ctz(M2);
    M2 &= M2 - 1;
  }

  let qq = [new Int32Array([~3, ~4, ~5, 0, 1, 2, 6, 7, 8]), 
    new Int32Array([~3, ~4, ~5, ~0, ~1, ~2, 6, 7, 8]),
    new Int32Array([~3, ~4, ~5, 2, 1, 0, 6, 7, 8]),
    new Int32Array([~3, ~4, ~5, ~2, ~1, ~0, 6, 7, 8])];

  for (let i = 0; i < qq.length; i++) {
    let actionQ = qq[i];
    let actionRem = multiply(multiply(action, inverse(actionS)), inverse(actionQ));
    let S = solveSingleStep(actionS);
    let Q = solveSingleStep(actionQ);
    let Rem1 = solveSingleStep(actionRem);
    if (S && Q && Rem1) {
      //debugger;
      return [S, Q, Rem1];
    }
    let Rem2 = solveTwoStep(actionRem);
    if (S && Q && Rem2) {
      //debugger;
      return [S, Q, ...Rem2];
    }
    let Rem3 = solveSQS(actionRem);
    if (S && Q && Rem3) {
      //debugger;
      return [S, Q, ...Rem3];
    }
  }
  return null;
}

function nextperm(A) {
  var len = A.length;
  var i = len - 2;
  var j = len - 1;
  
  while (i >= 0 && A[i] >= A[i + 1]) i--;
  
  if (i >= 0) {
    while (j > i && A[j] <= A[i]) j--;
    let t = A[i];
    A[i] = A[j];
    A[j] = t;
    A.subarray(i + 1).reverse();
  }
  else {
    A.reverse();
  }
}

function solve(totalAction) {
  let ss = solveSingleStep(totalAction);
  if (ss)
    return [[ss]];

  let ts = solveTwoStep(totalAction);
  if (ts)
    return [ts];
  let solutions = [];
  let SQS = solveSQS(totalAction);
  if (SQS)
    solutions.push(SQS);

  let qid = new Int32Array([~3, ~4, ~5, 0, 1, 2, 6, 7, 8]);

  {
    let Q = solveSingleStep(qid);
    let actionRem = multiply(totalAction, inverse(qid));
    let actionRemR = multiply(inverse(qid), totalAction);
    let SQ = solveTwoStep(actionRem);
    if (SQ) {
      SQ.unshift(Q);
      solutions.push(SQ);
    }
    let SQR = solveTwoStep(actionRemR);
    if (SQR) {
      SQR.push(Q);
      solutions.push(SQR);
    }
  }

  if (solutions.length > 0)
    return solutions;

  {
    let Q = solveSingleStep(qid);
    let actionRem = multiply(totalAction, inverse(qid));
    let actionRemR = multiply(inverse(qid), totalAction);
    let SQS = solveSQS(actionRem);
    if (SQS) {
      SQS.unshift(Q);
      solutions.push(SQS);
    }
    let SQSR = solveSQS(actionRemR);
    if (SQSR) {
      SQSR.push(Q);
      solutions.push(SQSR);
    }
  }

  if (solutions.length > 0)
    return solutions;

  let SQSQS = solveSQSQS(totalAction);
  if (SQSQS)
    return [SQSQS];
  
  return null;
}

function testAll(testalts) {
  let action = new Int32Array([0, 1, 2, 3, 4, 5, 6, 7, 8]);
  let logged = 0;
  let count = 0;
  do {
    let x = 0;
    if (action.every((a, i) => a == i))
      x = 1;
    for (let m = x; m < 64; m++) {
      let actionM = action.map((a, i) => a ^ -((m >> i) & 1));
      let solution = solve(actionM).map(turnSintoS16);
      if (!solution || solution.length == 0) {
        console.log(actionM.join(","));
        return;
      }
      else {
        let id = new Int32Array([0, 1, 2, 3, 4, 5, 6, 7, 8]);
        solution.forEach(s => {
          let reconstruct = s.reduce((a, b) => multiply(b.action, a), id);
          if (!reconstruct.every((a, i) => a === actionM[i]))
            console.log(actionM);
        });
        if (testalts) {
          let alts = generateAlternatives(solution);
          if (solution[0].length >= 4 && alts[0][0].kind == 'Q') {
            logged++;
            console.log({"alt": actionM});
          }
        }
        count++;
        if (count % 100000 == 0)
          console.log("count: " + count);
        if (logged >= 5)
          return;
      }
    }
    nextperm(action);
  } while (action.some((a, i) => a != i));
  return count;
}

function turnSintoS16(s) {
  let steps = s.slice();
  for (let i = 0; i < steps.length; i++) {
    if (steps[i].kind == 'S' && steps[i].action.every((a, i) => {
      if (i < 3)
        return a === i;
      if (i < 7)
        return (a ^ (a >> 31)) < 7 && (a ^ (a >> 31)) >= 3;
      return a === i;
    })) {
      steps[i].kind = 'S16';
      if (steps[i].action.every((a, i) => {
        if (i < 3)
          return a === i;
        if (i < 6)
          return (a ^ (a >> 31)) < 6 && (a ^ (a >> 31)) >= 3;
        return a === i;
      }))
        steps[i].kind = 'S8';
    }
  }
  return steps;
}

function generateAlternatives(solutions) {
  function opstring(steps) {
    return steps.map(s => s.kind).join(',');
  }
  function strictlyDominates(a, b) {
    let a_s_count = a.reduce((n, s) => s.kind == 'S' ? n+1:n);
    let b_s_count = b.reduce((n, s) => s.kind == 'S' ? n+1:n);
    return a_s_count < b_s_count;
  }
  function generateAlts(steps) {
    let alts = [];
    for (let i = 0; i < steps.length - 1; i++) {
      let totalAction = multiply(steps[i + 1].action, steps[i].action);
      let ss = solveSingleStep(totalAction);
      if (ss) {
        // can replace 2 steps with 1
        let alt = steps.slice();
        alt.splice(i, 2, ...turnSintoS16([ss]));
        alts.push(alt);
      }
      let ts = solveTwoStep(totalAction, true);
      ts.forEach(tt => {
        // can replace 2 steps with 2
        let alt = steps.slice();
        alt.splice(i, 2, ...turnSintoS16(tt));
        alts.push(alt);
      });
      if (totalAction.every((a, i) => {
        // low 3 bits only depend on low 3 bits
        // middle 3 bits only depend on middle 3 bits
        // top 3 bits unchanged
        if (i < 3)
          return (a ^ (a >> 31)) < 3;
        if (i < 6)
          return (a ^ (a >> 31)) >= 3 && (a ^ (a >> 31)) < 6;
        return a === i;
      })) {
        let qaction1 = new Int32Array([~3, ~4, ~5, 0, 0, 0, 6, 7, 8]);
        qaction1.set(totalAction.slice(0, 3).map(a => ~a), 3);
        let Q1 = solveSingleStep(qaction1);
        let qaction2 = multiply(totalAction, inverse(qaction1));
        let Q2 = solveSingleStep(qaction2);
        if (Q1 && Q2) {
          let alt = steps.slice();
          alt.splice(i, 2, Q1, Q2);
          alts.push(alt);
        }
      }
      if (totalAction.every((a, i) => {
        // low 3 bits depend on middle 3 bits
        // middle 3 bits depend on low 3 bits
        // top 3 bits unchanged
        if (i < 3)
          return (a ^ (a >> 31)) >= 3 && (a ^ (a >> 31)) < 6;
        if (i < 6)
          return (a ^ (a >> 31)) < 3;
        return a === i;
      })) {
        let qaction = new Int32Array([~3, ~4, ~5, 0, 0, 0, 6, 7, 8]);
        qaction.set(totalAction.slice(3, 6), 3);
        let Q = solveSingleStep(qaction);
        let paction = multiply(totalAction, inverse(qaction));
        let P = solveSingleStep(paction);
        if (Q && P) {
          let alt = steps.slice();
          alt.splice(i, 2, Q, P);
          alts.push(alt);
        }
      }
    }

    for (let i = 0; i < steps.length - 2; i++) {
      let totalAction = multiply(steps[i + 2].action, multiply(steps[i + 1].action, steps[i].action));
      let ss = solveSingleStep(totalAction);
      if (ss) {
        // can replace 3 steps with 1
        let alt = steps.slice();
        alt.splice(i, 3, ...turnSintoS16([ss]));
        alts.push(alt);
      }
      let ts = solveTwoStep(totalAction, true);
      ts.forEach(tt => {
        // can replace 3 steps with 2
        let alt = steps.slice();
        alt.splice(i, 3, ...turnSintoS16(tt));
        alts.push(alt);
      });
      let trs = solveSQS(totalAction);
      if (trs) {
        // can replace 3 steps with 3
        let alt = steps.slice();
        alt.splice(i, 3, ...turnSintoS16(trs));
        alts.push(alt);
      }
    }

    return alts;
  }

  solutions = solutions.slice();
  let worklist = solutions;
  let seenSoFar = new Set(solutions.map(opstring));
  do {
    let newwork = worklist.flatMap(generateAlts).map(turnSintoS16);
    // only keep previously unseen solutions
    let nextlist = [];
    newwork.forEach(w => {
      let op = opstring(w);
      if (!seenSoFar.has(op)) {
        seenSoFar.add(op);
        nextlist.push(w);
      }
    });
    worklist = nextlist;
    solutions.push(...worklist);
  } while (worklist.length > 0);

  return solutions.filter(s => !solutions.some(x => strictlyDominates(x, s)));
}

function shufbits(i, action) {
  let r = 0;
  for (let j = 0; j < 9; j++) {
    let a = action[j];
    if ((i ^ (a >> 31)) & (1 << j))
      r |= 1 << (a ^ (a >> 31));
  }
  return r;
}

function action_to_shufvector(action) {
  let s = new Int8Array(64);
  for (let i = 0; i < 64; i++) {
    s[i] = shufbits(i << 3, action) >> 3;
  }
  return s;
}

function action_to_qmat(action) {
  let s = 0n;
  for (let i = 0; i < 64; i += 8) {
    s |= 1n << BigInt(i + shufbits(i ^ 7, action));
  }
  return s;
}

function action_to_pmat(action) {
  let s = 0n;
  for (let i = 0; i < 64; i += 8) {
    s |= 1n << BigInt(i + shufbits((i >> 3) ^ 7, action));
  }
  return s;
}

function stepToCode(state, step) {
  if (step.kind == 'S') {
    if (step.action.every((a, i) => {
      if (i < 7)
        return a === i;
      return (a ^ (a >> 31)) === 7 || (a ^ (a >> 31)) === 8;
    })) {
      // vshufi64x2
      let t1 = shufbits(0, step.action) >> 7;
      let t2 = shufbits(1 << 7, step.action) >> 7;
      let t3 = shufbits(2 << 7, step.action) >> 7;
      let t4 = shufbits(3 << 7, step.action) >> 7;
      state.maincode += "    x = _mm512_shuffle_i64x2(x, x, _MM_SHUFFLE(" + [t4, t3, t2, t1].join(", ") + "));\n";
    }
    else if (step.action.every((a, i) => {
      if (i < 6 || i === 8)
        return a === i;
      return (a ^ (a >> 31)) === 6 || (a ^ (a >> 31)) === 7;
    })) {
      // vpermq
      let t1 = shufbits(0, step.action) >> 6;
      let t2 = shufbits(1 << 6, step.action) >> 6;
      let t3 = shufbits(2 << 6, step.action) >> 6;
      let t4 = shufbits(3 << 6, step.action) >> 6;
      state.maincode += "    x = _mm512_permutex_epi64(x, _MM_SHUFFLE(" + [t4, t3, t2, t1].join(", ") + "));\n";
    }
    else {
      let shufstr = step.action.join(",");
      let constantname = null;
      if (state.constants[shufstr])
        constantname = state.constants[shufstr];
      else {
        constantname = "s" + (state.constidx++);
        state.constants[shufstr] = constantname;
        let shuf = action_to_shufvector(step.action);
        shuf.reverse();
        state.topcode += "    __m512i " + constantname + " = _mm512_set_epi8(";
        for (let i = 0; i < 8; i++) {
          state.topcode += "\n        " + shuf.slice(i * 8, i * 8 + 8).join(", ");
          if (i < 7)
            state.topcode += ",";
        }
        state.topcode += ");\n";
      }
      state.maincode += "    x = _mm512_permutexvar_epi8(" + constantname + ", x);\n";
    }
  }
  else if (step.kind == 'S16' || step.kind == 'S8') {
    if (step.action.every((a, i) => {
      if (i == 6)
        return ~a === i;
      return a === i;
    })) {
      // vpalignr
      state.maincode += "    x = _mm512_alignr_epi8(x, x, 8);\n";
    }
    else if (step.action.every((a, i) => {
      if (i == 5)
        return ~a === i;
      return a === i;
    })) {
      // vprolq
      state.maincode += "    x = _mm512_rol_epi64(x, 32);\n";
    }
    else if (step.action.every((a, i) => {
      if (i == 4)
        return ~a === i;
      return a === i;
    })) {
      // vprold
      state.maincode += "    x = _mm512_rol_epi32(x, 16);\n";
    }
    else if (step.action.every((a, i) => {
      if (i == 3)
        return ~a === i;
      return a === i;
    })) {
      // vprolw
      state.maincode += "    x = _mm512_rol_epi16(x, 8);\n";
    }
    else if (step.action.every((a, i) => {
      if (i < 5)
        return a === i;
      if (i < 7)
        return (a ^ (a >> 31)) === 5 || (a ^ (a >> 31)) === 6;
      return a === i;
    })) {
      // vpshufd
      let t1 = shufbits(0, step.action) >> 5;
      let t2 = shufbits(1 << 5, step.action) >> 5;
      let t3 = shufbits(2 << 5, step.action) >> 5;
      let t4 = shufbits(3 << 5, step.action) >> 5;
      state.maincode += "    x = _mm512_shuffle_epi32(x, _MM_SHUFFLE(" + [t4, t3, t2, t1].join(", ") + "));\n";
    }
    else {
      let shufstr = step.action.join(",");
      let constantname = null;
      if (state.constants[shufstr])
        constantname = state.constants[shufstr];
      else {
        constantname = "s" + (state.constidx++);
        state.constants[shufstr] = constantname;
        let shuf = action_to_shufvector(step.action).map(a => a & 15);
        shuf.reverse();
        state.topcode += "    __m512i " + constantname + " = _mm512_set_epi8(";
        for (let i = 0; i < 8; i++) {
          state.topcode += "\n        " + shuf.slice(i * 8, i * 8 + 8).join(", ");
          if (i < 7)
            state.topcode += ",";
        }
        state.topcode += ");\n";
      }
      state.maincode += "    x = _mm512_shuffle_epi8(x, " + constantname + ");\n";
    }
  }
  else if (step.kind == 'Q') {
    let qmat = action_to_qmat(step.action);
    let shufstr = qmat.toString(16);
    shufstr = "0x" + ("0000000000000000" + shufstr).slice(-16);
    let constantname = null;
    if (state.constants[shufstr])
      constantname = state.constants[shufstr];
    else {
      constantname = "m" + (state.constidx++);
      state.constants[shufstr] = constantname;
      state.topcode += "    __m512i " + constantname + " = _mm512_set1_epi64(" + shufstr + ");\n";
    }
    state.maincode += "    x = _mm512_gf2p8affine_epi64_epi8(" + constantname + ", x, 0);\n";
  }
  else if (step.kind == 'P') {
    let pmat = action_to_pmat(step.action);
    let shufstr = pmat.toString(16);
    shufstr = "0x" + ("0000000000000000" + shufstr).slice(-16);
    let constantname = null;
    if (state.constants[shufstr])
      constantname = state.constants[shufstr];
    else {
      constantname = "m" + (state.constidx++);
      state.constants[shufstr] = constantname;
      state.topcode += "    __m512i " + constantname + " = _mm512_set1_epi64(" + shufstr + ");\n";
    }
    state.maincode += "    x = _mm512_gf2p8affine_epi64_epi8(x, " + constantname + ", 0);\n";
  }

}

function makeCodeForSteps(steps) {
  let state = { constidx: 1, constants: {}, topcode: "", maincode: "" };
  for (let i = 0; i < steps.length; i++)
    stepToCode(state, steps[i]);
  let code = "__m512i shuffle_bits(__m512i x) {\n" + state.topcode + state.maincode + "    return x;\n}";
  return code;
}

function performQuery(permute) {
  data = {};
  permute = permute.trim();
  if (permute.startsWith("b")) {
    let parts = permute.slice(1).split(",");
    let indices = new Int32Array(9);
    indices.fill(0x1ea7beef);
    let mask = 0;
    for (let i = 0; i < parts.length && i < 9; i++) {
      let sign = 0;
      let p = parts[i].trim();
      if (p.startsWith("~")) {
        sign = -1;
        p = p.slice(1);
      }

      let x = parseInt(p);
      if (x < 0 || isNaN(x) || x > 8) {
        data.msg = "bad index";
        update();
        return;
      }
      indices[i] = x ^ sign;
      if (mask & (1 << x)) {
        data.msg = "duplicate index(" + x + ")";
        update();
        return;
      }
      mask |= 1 << x;
    }

    if (mask != 0x1FF) {
      data.msg = "incomplete index(" + ctz(mask ^ 0x1FF) + ")";
      update();
      return;
    }

    if (indices.some(a => a == 0x1ea7beef)) {
      data.msg = "incomplete index(" + indices.indexOf(a => a  == 0x1ea7beef) + ")";
      update();
      return;
    }

    data.indices = indices;
  }
  else {
    let parts = permute.split(",");
    let bitpos = new Int32Array(512);
    bitpos.fill(-1);
    let bitidx = 0;
    let mask = 0n;
    for (let i = 0; i < parts.length && i < 512; i++) {
      let val = parseInt(parts[i]);
      if (val < 0 || isNaN(val) || val > 511) {
        data.msg = "bad index";
        update();
        return;
      }
      bitpos[bitidx++] = val;
      mask |= 1n << BigInt(val);
    }

    if ((mask + 1n) !== (1n << 512n)) {
      let maskbin = mask.toString(2);
      data.msg = "incomplete index (" + (maskbin.length - 1 - maskbin.lastIndexOf('0')) + ")";
      update();
      return;
    }

    if (bitpos.some(a => a < 0)) {
      data.msg = "incomplete index (" + bitpos.indexOf(a => a < 0) + ")";
      update();
      return;
    }

    let idx = extract_bit_indexes(bitpos);

    if (idx == null) {
      data.msg = "not a BPC permutation";
      update();
      return;
    }
    data.indices = idx;
  }

  data.inverse = inverse(data.indices);

  data.solutions = solve(data.indices);
  if (data.solutions) {
    data.solutions = generateAlternatives(data.solutions.map(turnSintoS16));
  }
  
  update();
  
  
  
}

function bitpermToString(bitperm) {
  let s = "";
  for (let i = 0; i < bitperm.length; i++) {
    if (i > 0)
      s += ",";
    s += bitperm[i] < 0 ? "~" + ~bitperm[i] : "" + bitperm[i];
  }
  return s;
}

var data = null;

function update() {
  parens = $j('#explicitparens').is(':checked');
  $j('#resultDiv').empty();
  
  if (data == null || data == undefined) {
    $j('#resultDiv').append("Query Failed");
    return;
  }

  if (data.msg) {
    $j('#resultDiv').append(data.msg);
    return;
  }

  if (data.indices) {
    let ind = $j('<div/>');
    ind.append($j('<span>Indices:</span>').css({'display': 'inline-block', 'width': '5em'}));
    ind.append(' 876543210 ⇒ ');
    for (let i = data.indices.length - 1; i >= 0; i--) {
      let d = data.indices[i];
      d ^= d >> 31;
      if (data.indices[i] < 0)
        ind.append('<span style="text-decoration:overline">' + d + '</span>');
      else
        ind.append(d + '');
    }
    $j('#resultDiv').append(ind);
  }

  if (data.inverse) {
    let ind = $j('<div/>');
    ind.append($j('<span>Inverse:</span>').css({'display': 'inline-block', 'width': '5em'}));
    ind.append(' 876543210 ⇒ ');
    let a = $j('<a>').attr('href', 'avx512bpc.html?q=' + encodeURIComponent('b ' + bitpermToString(data.inverse)));
    a.css('text-decoration', 'none');
    for (let i = data.inverse.length - 1; i >= 0; i--) {
      let d = data.inverse[i];
      d ^= d >> 31;
      if (data.inverse[i] < 0)
        a.append('<span style="text-decoration:overline">' + d + '</span>');
      else
        a.append(d + '');
    }
    ind.append(a);
    $j('#resultDiv').append(ind);
  }

  if (data.solutions) {
    let sol = $j('<div/>');
    for (let i = 0; i < data.solutions.length; i++) {
      let s = $j('<div/>');

      let sstring = "";
      for (let j = 0; j < data.solutions[i].length; j++)
        sstring += data.solutions[i][j].kind + " ";
      s.append(sstring);

      let codebox = $j('<pre/>');
      s.append(codebox);
      codebox.append(makeCodeForSteps(data.solutions[i]));

      sol.append(s);
    }
    $j('#resultDiv').append($j('<br/>'));
    $j('#resultDiv').append(sol);
  }

}

function doquery(q) {
  if (q === undefined || q == null || q.length == 0 || q === 0)
    return;
  $j('#q').val(decodeURIComponent(q.replace(/\+/g, " ")));
  $j('#resultDiv').empty();
  $j('#resultDiv').text('Waiting for result...');
  performQuery(decodeURIComponent(q.replace(/\+/g, " ")));
}
$j(document).ready(function(){
  doquery(urlParam('q'));
});
</script>
</head>
<body>
<div id="header"><h1>AVX512 BPC permute (v0.1)</h1>
</div>
<div id="querybar">
  <div id="querybox">
    <form method="get">
      <input type="text" placeholder="permutation" name="q" id="q" autofocus/>
      <input type="submit" value="compute" id="submit"/>
    </form>
  </div>
</div>
<div id="page">
  <div id="query-printback"></div>
  <div id="resultDiv"></div>
  <div id="examples">
    <h2>Examples</h2>
    <p>Bit-reverse every byte<br/>
      &nbsp;&nbsp;&nbsp;&nbsp;<a href="avx512bpc.html?q=b+~0%2C~1%2C~2%2C3%2C4%2C5%2C6%2C7%2C8"><tt>b ~0,~1,~2,3,4,5,6,7,8</tt></a></p>
    <p>Turn vector of 8 u64 into 64 u8 (transpose 8x64)<br/>
      &nbsp;&nbsp;&nbsp;&nbsp;<a href="avx512bpc.html?q=b 6%2C7%2C8%2C0%2C1%2C2%2C3%2C4%2C5"><tt>b 6,7,8,0,1,2,3,4,5</tt></a></p>
    <p>Turn vector of 16 u32 into 32 u16 (transpose 16x32)<br/>
      &nbsp;&nbsp;&nbsp;&nbsp;<a href="avx512bpc.html?q=b+5%2C6%2C7%2C8%2C0%2C1%2C2%2C3%2C4"><tt>b 5,6,7,8,0,1,2,3,4</tt></a></p>
    <p>16x16 transpose in each 256-bit part<br/>
      &nbsp;&nbsp;&nbsp;&nbsp;<a href="avx512bpc.html?q=b+4%2C5%2C6%2C7%2C0%2C1%2C2%2C3%2C8"><tt>b 4,5,6,7,0,1,2,3,8</tt></a></p>
      
  </div>
  <div>
    <h2>Notes</h2>    
    <p>You can dump a full array of 512 indices into the query box (no prefix, comma-separated, spaces are allowed), or 9 indices-of-bits-of-indices (with the "b" prefix). If you use raw indices, the permutation must still correspond to a BPC permutation.</p>
    <p>Put the least-significant index first, but the print-back shows the indices most-significant-first. Use source indices in raw mode, but destination indices in <tt>b</tt> mode. Yes, it's confusing. Sorry.</p>
    <p>In <tt>b</tt> mode, the <tt>~</tt> operator is available to complement a bit. It does not complement the <i>number</i> after it, but the corresponding bit.</p>
    <p>Consider this an alpha version for now. Expect bugs. You can <a href="https://gitlab.com/haroldaptroot/haroldbot/-/issues">open an issue</a> or contact me (eg via email, <a rel="me" href="https://mastodon.gamedev.place/@harold">Mastodon</a> @harold@mastodon.gamedev.place or twitter @HaroldAptroot).</p>
  </div>
</div>
</body>
</html>
